diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
index 98a4889b0..a10760ca0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
@@ -27,6 +27,13 @@ public class SurfaceGeneratorNether
         this.soilNoise = new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 4, 44));
     }
 
+    private boolean safeToPlacePool(ChunkGeneratorResult result, int x, int y, int z) {
+        if(x<0||x>15||z<0||z>15) return true;
+        if(y < world.getWorldType().getMinY(world) || y > world.getWorldType().getMaxY(world)) return false;
+        int id = result.getBlock(x, y, z);
+        return id != 0;
+    }
+
     @Override
     public void generateSurface(@NotNull Chunk chunk, @NotNull ChunkGeneratorResult result) {
         int oceanY = this.world.getWorldType().getOceanY();
@@ -44,10 +51,12 @@ public class SurfaceGeneratorNether
         double[] sandBeachNoise = this.beachNoise.getRegion(null, chunkX * 16, chunkZ * 16, 0.0D, 16, 16, 1, beachScale, beachScale, 1.0D);
         double[] gravelBeachNoise = this.beachNoise.getRegion(null, chunkX * 16, 109.0134D, chunkZ * 16, 16, 1, 16, beachScale, 1.0D, beachScale);
         double[] soilThicknessNoise = this.soilNoise.getRegion(null, chunkX * 16, chunkZ * 16, 0.0D, 16, 16, 1, beachScale * 2D, beachScale * 2D, beachScale * 2D);
+        double[] sandPatchNoise = this.soilNoise.getRegion(null, chunkX * 16, chunkZ * 16, 0.0D, 16, 16, 1, beachScale * 2D, beachScale * 2D, beachScale);
         for (int z = 0; z < 16; z++) {
             for (int x = 0; x < 16; x++) {
-                boolean generateSandBeach = sandBeachNoise[z + x * 16] + rand.nextDouble() * 0.2D > 0.0D;
+                boolean generateSoulSandBeach = sandBeachNoise[z + x * 16] + rand.nextDouble() * 0.2D > 0.0D;
                 boolean generateGravelBeach = gravelBeachNoise[z + x * 16] + rand.nextDouble() * 0.2D > 0.0D;
+                boolean generateSulfurPool = gravelBeachNoise[z + x * 16] / 3D + 3D + rand.nextDouble() * 0.5D > 3.D;
                 int soilThickness = (int) (soilThicknessNoise[z + x * 16] / 3D + 3D + rand.nextDouble() * 0.25D);
 
                 int currentLayerDepth = -1;
@@ -75,7 +84,7 @@ public class SurfaceGeneratorNether
                         continue;
                     }
 
-                    // will skip a generation loop if it encounters something other than netherrack
+                    // will skip a generation loop if it encounters something other than Netherrack (or basalt for the sulfur pools)
                     if (block != worldFillBlock) {
                         continue;
                     }
@@ -85,7 +94,7 @@ public class SurfaceGeneratorNether
                         // if soil thickness is below 0, generate a stone basin where there is no top block layer
                         if (soilThickness <= 0) {
                             topBlock = 0;
-                            fillerBlock = (short) worldFillBlock;
+                            fillerBlock = (short) Blocks.NETHERRACK.id();
                         } else {
                             boolean biomeGeneratesSulfur = biome == Biomes.NETHER_SULFUR_POOLS;
 
@@ -93,20 +102,17 @@ public class SurfaceGeneratorNether
                                 // Generate coastlines
                                 topBlock = biome.topBlock;
                                 fillerBlock = biome.fillerBlock;
-                                if (biomeGeneratesSulfur) {
-                                    topBlock = (short) Blocks.SULFUR.id();
-                                    fillerBlock = (short) Blocks.SULFUR.id();
-                                } else if (generateGravelBeach) {
+                                if (generateGravelBeach) {
                                     topBlock = (short) Blocks.GRAVEL.id();
-                                    fillerBlock = (short) Blocks.COBBLE_NETHERRACK.id();
-                                } else if (generateSandBeach) {
+                                    fillerBlock = (short) Blocks.GRAVEL.id();
+                                } if (generateSoulSandBeach) {
                                     topBlock = (short) Blocks.SOULSAND.id();
                                     fillerBlock = (short) Blocks.SOULSAND.id();
                                 }
                             } else if (y <= oceanY) {
                                 if (biomeGeneratesSulfur) {
-                                    topBlock = (short) Blocks.SULFUR.id();
-                                    fillerBlock = (short) Blocks.SULFUR.id();
+                                    topBlock = (short) Blocks.BRIMSAND.id();
+                                    fillerBlock = (short) Blocks.BRIMSAND.id();
                                 }
                             }
                         }
@@ -116,7 +122,7 @@ public class SurfaceGeneratorNether
                             topBlock = (short) oceanBlock;
                         }
                         // if a new surface layer has been chosen to be generated, set the current layer depth to the generated soil thickness level and begin generating downwards
-                        currentLayerDepth = soilThickness;
+                        currentLayerDepth = soilThickness+2;
 
                         // set block at index to designated surface block above ocean level
                         if (y >= minY + oceanY - 1) {
@@ -133,6 +139,14 @@ public class SurfaceGeneratorNether
                         currentLayerDepth--;
                         result.setBlock(x, y, z, fillerBlock);
                     }
+
+                    if(currentLayerDepth == 0)
+                    {
+                        if(biome == Biomes.NETHER_SULFUR_POOLS && fillerBlock == Blocks.BRIMSAND.id()) {
+                            currentLayerDepth = rand.nextInt(4) + 2;
+                            fillerBlock = (short)Blocks.BRIMSAND.id();
+                        }
+                    }
                 }
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
index 1e165ed96..28ffa3202 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
@@ -24,10 +24,6 @@ public class TerrainGeneratorNether
     private final int lastX = Integer.MIN_VALUE;
     private final int lastZ = Integer.MIN_VALUE;
     private @Nullable Biome lastBiome = null;
-    private @Nullable Biome lastBiomeNegX = null;
-    private @Nullable Biome lastBiomePosX = null;
-    private @Nullable Biome lastBiomeNegZ = null;
-    private @Nullable Biome lastBiomePosZ = null;
     private final Object2IntMap<Biome> fluidLookup = new Object2IntArrayMap<>();
     private int lastChunkX = Integer.MIN_VALUE;
     private int lastChunkZ = Integer.MIN_VALUE;
@@ -41,52 +37,29 @@ public class TerrainGeneratorNether
 
         this.densityGenerator = new DensityGeneratorNether(world);
 
-        this.fluidLookup.put(Biomes.NETHER_NETHER, Blocks.FLUID_LAVA_STILL.id());
         this.fluidLookup.put(Biomes.NETHER_VOLCANIC_ISLANDS, Blocks.FLUID_LAVA_STILL.id());
-        this.fluidLookup.put(Biomes.NETHER_SULFUR_POOLS, Blocks.FLUID_WATER_STILL.id());
+        this.fluidLookup.put(Biomes.NETHER_SULFUR_POOLS, Blocks.FLUID_LAVA_STILL.id());
+        this.fluidLookup.put(Biomes.NETHER_CRAG, Blocks.FLUID_LAVA_STILL.id());
+        this.fluidLookup.put(Biomes.NETHER_SHELF, Blocks.COBBLE_NETHERRACK.id());
         this.fluidLookup.put(Biomes.NETHER_CRYSTAL_FOREST, Blocks.FLUID_WATER_STILL.id());
-        this.fluidLookup.put(Biomes.NETHER_ASH_PLAINS, Blocks.OBSIDIAN.id());
-        this.fluidLookup.put(Biomes.NETHER_BONEYARD, Blocks.COBBLE_NETHERRACK.id());
+        this.fluidLookup.put(Biomes.NETHER_CRYSTAL_FIELD, Blocks.FLUID_WATER_STILL.id());
+        this.fluidLookup.put(Biomes.NETHER_OLD_WORLD, Blocks.FLUID_WATER_STILL.id());
 
         this.minY = world.getWorldType().getMinY(world);
         this.maxY = world.getWorldType().getMaxY(world);
+
     }
 
     @Override
     protected int getBlockAt(@NotNull Chunk chunk, int x, int y, int z, double density) {
         if (this.lastX != x || this.lastZ != z) {
             this.lastBiome = chunk.getBlockBiome(x, 0, z);
-            if (x - 1 < 0) {
-                this.lastBiomeNegX = this.lastBiome;
-            } else {
-                this.lastBiomeNegX = chunk.getBlockBiome(x - 1, 0, z);
-            }
-            if (x + 1 >= Chunk.CHUNK_SIZE_X) {
-                this.lastBiomePosX = this.lastBiome;
-            } else {
-                this.lastBiomePosX = chunk.getBlockBiome(x + 1, 0, z);
-            }
-            if (z - 1 < 0) {
-                this.lastBiomeNegZ = this.lastBiome;
-            } else {
-                this.lastBiomeNegZ = chunk.getBlockBiome(x, 0, z - 1);
-            }
-            if (z + 1 >= Chunk.CHUNK_SIZE_Z) {
-                this.lastBiomePosZ = this.lastBiome;
-            } else {
-                this.lastBiomePosZ = chunk.getBlockBiome(x, 0, z + 1);
-            }
         }
+
         if (this.lastChunkX != chunk.pos.x || this.lastChunkZ != chunk.pos.z) {
             this.lastChunkX = chunk.pos.x;
             this.lastChunkZ = chunk.pos.z;
             this.noise.getRegion(this.cache, chunk.pos.x * Chunk.CHUNK_SIZE_X, 0, chunk.pos.z * Chunk.CHUNK_SIZE_Z, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, 0.2, 0.2, 0.2);
-
-            float avg = 0;
-            for (int i = 0; i < this.cache.length; i++) {
-                avg += this.cache[i];
-            }
-            avg /= this.cache.length;
         }
 
         WorldType type = this.world.getWorldType();
@@ -96,45 +69,21 @@ public class TerrainGeneratorNether
             return 0;
         } else if (y >= maxY - this.rand.nextInt(5)) {
             return Blocks.BEDROCK.id();
-        }
-//        else if (y >= quarterHeight - rand.nextInt(5) && y <= quarterHeight + 5 - rand.nextInt(5))
-//        {
-//            return Blocks.BEDROCK.id();
-//        }
-//        else if (y <= type.getMinY() + rand.nextInt(5))
-//        {
-//            return Blocks.BEDROCK.id();
-//        }
-//        else if (y <= quarterHeight)
-//        {
-//            return Blocks.SOULSCHIST.id();
-//        }
-        else if (y <= quarterHeight + this.rand.nextInt(5)) {
+        } else if (y <= quarterHeight + this.rand.nextInt(5)) {
             return Blocks.BEDROCK.id();
         } else if (density > 0.0) {
-            if (this.lastBiome == Biomes.NETHER_CRYSTAL_FOREST) {
+            if (this.lastBiome == Biomes.NETHER_CRYSTAL_FOREST || this.lastBiome == Biomes.NETHER_CRYSTAL_FIELD) {
                 int sizeY = Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y;
                 // YZX ordering
                 final double d = ((this.cache[(x * Chunk.CHUNK_SIZE_Z * sizeY) + (z * sizeY) + y]));
-                if (d > 0 && d < 2) {
-                    return Blocks.CRYSTAL.id();
-                } else if (d > -1 && d < 3) {
-                    return Blocks.COBBLE_NETHERRACK_MOSSY.id();
+                if (d > -1 && d < 2) {
+                    return Blocks.COBBLE_NETHERRACK_CRYSTALLINE.id();
                 }
             }
-            return type.getFillerBlockId();
-        } else if (y >= quarterHeight && y < type.getOceanY()) {
-            int biomeFluid = this.fluidLookup.getOrDefault(this.lastBiome, 0);
-            int biomeFluidNegX = this.fluidLookup.getOrDefault(this.lastBiomeNegX, 0);
-            int biomeFluidPosX = this.fluidLookup.getOrDefault(this.lastBiomePosX, 0);
-            int biomeFluidNegZ = this.fluidLookup.getOrDefault(this.lastBiomeNegZ, 0);
-            int biomeFluidPosZ = this.fluidLookup.getOrDefault(this.lastBiomePosZ, 0);
-
-            if (biomeFluid == biomeFluidNegX && biomeFluid == biomeFluidPosX && biomeFluid == biomeFluidNegZ && biomeFluid == biomeFluidPosZ) {
-                return biomeFluid;
-            }
 
-            return Blocks.OBSIDIAN.id();
+            return type.getFillerBlockId();
+        } else if (y < type.getOceanY()) {
+            return this.fluidLookup.getOrDefault(this.lastBiome, 0);
         }
 
         return 0;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureChimney.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureChimney.java
new file mode 100644
index 000000000..c895b7b97
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureChimney.java
@@ -0,0 +1,109 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import org.joml.Vector2i;
+
+import java.util.Random;
+
+public class WorldFeatureChimney extends WorldFeature{
+
+    final double[][] RADIUS_MAPS = {
+            {1.5D, 1.5D, 1D, 1D, 0D, 0D},
+            {1.5D, 1D, 1D, 0D, 0D},
+            {1.5D, 1D, 1D, 1D, 0D, 0D},
+            {1D, 0D, 0D},
+            {1.5D}
+    };
+
+    @Override
+    public boolean place(World world, Random random, int x, int y, int z) {
+        TilePos pos = new TilePos(x, y, z);
+        while(world.isAirBlock(pos) && pos.y - 1 > 0) {pos.down(); }
+
+        double[] map = RADIUS_MAPS[random.nextInt(5)];
+        if (hasSpace(world, pos.x, pos.y, pos.z)) {
+            Vector2i centerXZ = new Vector2i(pos.x, pos.z);
+            TilePos queryPos = new TilePos(pos.x, pos.y, pos.z);
+
+                for (int i = 0; i < map.length; i++) {
+                    generateRadius(world, centerXZ, queryPos, map[i], pos.y + i);
+                }
+
+            TilePos circlePos = new TilePos();
+            for (circlePos.x = pos.x() - 2; circlePos.x < pos.x() + 2; circlePos.x++) {
+                for (circlePos.z = pos.z() - 2; circlePos.z < pos.z() + 2; circlePos.z++) {
+                    for (circlePos.y = pos.y() - 4; circlePos.y < pos.y + 4; circlePos.y++) {
+
+                        if (!world.isAirBlock(circlePos)) {
+                            if (random.nextInt(8) == 0)
+                                world.setBlockType(circlePos, Blocks.MAGMA);
+                            else if (random.nextInt(4) == 0)
+                                world.setBlockType(circlePos, Blocks.COBBLE_BASALT);
+                        }
+                    }
+                }
+            }
+        }
+
+
+        return true;
+    }
+
+    private Block<?> getBlockAt(Vector2i center, int x, int z){
+        if(x == center.x && z == center.y){
+            return Blocks.THERMAL_VENT;
+        }
+        return Blocks.COBBLE_BASALT;
+    }
+
+    private void plotBlocks(World world, Vector2i center, TilePos queryPos, int x, int y, int z){
+
+        for(int xx = center.x - x; xx <= center.x + x; xx++) {
+            Block<?> block = getBlockAt(center, xx, center.y + z);
+            world.setBlockType(queryPos.set(xx, queryPos.y, center.y + z), block);
+            world.setBlockType(queryPos.set(xx, queryPos.y, center.y - z), block);
+        }
+
+        for(int xx = center.x - z; xx <= center.x + z; xx++) {
+            Block<?> block = getBlockAt(center, xx, center.y + x);
+            world.setBlockType(queryPos.set(xx, y, center.y + x), block);
+            world.setBlockType(queryPos.set(xx, y, center.y - x), block);
+        }
+    }
+
+    private void generateRadius(World world, Vector2i center, TilePos queryPos, double r, int y){
+        int x = 0;
+        int z = (int) r;
+        double d = 3 - 2 * r;
+        plotBlocks(world, center, queryPos, x, y, z);
+        while (z > x){
+            x++;
+            if (d > 0) {
+                z--;
+                d = d + 4 * (x - z) + 10;
+            }  else
+                d = d + 4 * x + 6;
+
+            plotBlocks(world, center, queryPos, x, y, z);
+        }
+    }
+
+    private boolean hasSpace(World world, int xc, int y, int zc){
+        TilePos queryPos =  new TilePos();
+        for (queryPos.y = y - 2; queryPos.y < y + 2; queryPos.y++) {
+            for (queryPos.x = xc - 2; queryPos.x < xc + 2; queryPos.x++) {
+                for (queryPos.z = zc - 2; queryPos.z < zc + 2; queryPos.z++) {
+                    if (!world.isAirBlock(queryPos) && !world.getBlockType(queryPos).hasTag(BlockTags.NETHER_SURFACE_BLOCK))
+                        return false;
+                }
+            }
+        }
+        return true;
+    }
+
+
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java
index f2506450d..8560a7512 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java
@@ -15,14 +15,15 @@ public class WorldFeatureFire extends WorldFeature
     @Override
 	public boolean place(World world, Random random, int x, int y, int z)
     {
-        for(int l = 0; l < 64; l++)
+        for(int i = 0; i < 32; i++)
         {
-            int i1 = (x + random.nextInt(8)) - random.nextInt(8);
-            int j1 = (y + random.nextInt(4)) - random.nextInt(4);
-            int k1 = (z + random.nextInt(8)) - random.nextInt(8);
-            if(world.isAirBlock(i1, j1, k1) && world.getBlockId(i1, j1 - 1, k1) == Blocks.COBBLE_NETHERRACK.id())
+            int x1 = (x + random.nextInt(8)) - random.nextInt(8);
+            int y1 = (y + random.nextInt(4)) - random.nextInt(4);
+            int z1 = (z + random.nextInt(8)) - random.nextInt(8);
+            if(world.isAirBlock(x1, y1, z1) && (world.getBlockId(x1, y1 - 1, z1) == Blocks.COBBLE_NETHERRACK.id() || world.getBlockId(x1, y1 - 1, z1) == Blocks.BRIMSAND.id()))
             {
-                world.setBlockWithNotify(i1, j1, k1, Blocks.FIRE.id());
+                world.setBlockWithNotify(x1, y1, z1, Blocks.FIRE.id());
+                world.setBlock(x1, y1 - 1, z1, Blocks.COBBLE_NETHERRACK.id());
             }
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
index 47d2a78bd..78134e604 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
@@ -16,32 +16,32 @@ public class WorldFeatureLiquid extends WorldFeature
     @Override
 	public boolean place(World world, Random random, int x, int y, int z)
     {
-        if(world.getBlockId(x, y + 1, z) != Blocks.STONE.id())
+        if(world.getBlockId(x, y + 1, z) != Blocks.STONE.id()|| world.getBlockId(x, y + 1, z) != Blocks.COBBLE_NETHERRACK.id())
         {
             return false;
         }
-        if(world.getBlockId(x, y - 1, z) != Blocks.STONE.id())
+        if(world.getBlockId(x, y - 1, z) != Blocks.STONE.id()|| world.getBlockId(x, y - 1, z) != Blocks.COBBLE_NETHERRACK.id())
         {
             return false;
         }
-        if(world.getBlockId(x, y, z) != 0 && world.getBlockId(x, y, z) != Blocks.STONE.id())
+        if(world.getBlockId(x, y, z) != 0 && world.getBlockId(x, y, z) != Blocks.STONE.id()|| world.getBlockId(x, y, z) != Blocks.COBBLE_NETHERRACK.id())
         {
             return false;
         }
         int l = 0;
-        if(world.getBlockId(x - 1, y, z) == Blocks.STONE.id())
+        if(world.getBlockId(x - 1, y, z) == Blocks.STONE.id() || world.getBlockId(x - 1, y, z) == Blocks.COBBLE_NETHERRACK.id())
         {
             l++;
         }
-        if(world.getBlockId(x + 1, y, z) == Blocks.STONE.id())
+        if(world.getBlockId(x + 1, y, z) == Blocks.STONE.id()|| world.getBlockId(x + 1, y, z) == Blocks.COBBLE_NETHERRACK.id())
         {
             l++;
         }
-        if(world.getBlockId(x, y, z - 1) == Blocks.STONE.id())
+        if(world.getBlockId(x, y, z - 1) == Blocks.STONE.id()|| world.getBlockId(x, y, z - 1) == Blocks.COBBLE_NETHERRACK.id())
         {
             l++;
         }
-        if(world.getBlockId(x, y, z + 1) == Blocks.STONE.id())
+        if(world.getBlockId(x, y, z + 1) == Blocks.STONE.id()|| world.getBlockId(x, y, z + 1) == Blocks.COBBLE_NETHERRACK.id())
         {
             l++;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMagmaBoulder.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMagmaBoulder.java
new file mode 100644
index 000000000..d2912096f
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMagmaBoulder.java
@@ -0,0 +1,103 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import org.joml.Vector2i;
+
+import java.util.Random;
+
+public class WorldFeatureMagmaBoulder extends WorldFeature{
+
+    final double[][] RADIUS_MAPS = {
+            {1.5D, 1.5D, 1D},
+            {1D, 1.5D, 1D},
+    };
+
+    @Override
+    public boolean place(World world, Random random, int x, int y, int z) {
+        TilePos pos = new TilePos(x, y, z);
+        while(world.isAirBlock(pos) && pos.y - 1 > 0) {pos.down(); }
+
+        double[] map = RADIUS_MAPS[random.nextInt(2)];
+        if (hasSpace(world, pos.x, pos.y, pos.z)) {
+            Vector2i centerXZ = new Vector2i(pos.x, pos.z);
+            TilePos queryPos = new TilePos(pos.x, pos.y, pos.z);
+
+            for (int i = 0; i < map.length; i++) {
+                generateRadius(world, centerXZ, queryPos, map[i], pos.y + i);
+            }
+
+            TilePos circlePos = new TilePos();
+            for (circlePos.x = pos.x() - 2; circlePos.x < pos.x() + 2; circlePos.x++) {
+                for (circlePos.z = pos.z() - 2; circlePos.z < pos.z() + 2; circlePos.z++) {
+                    for (circlePos.y = pos.y() - 4; circlePos.y < pos.y + 4; circlePos.y++) {
+
+                        if (!world.isAirBlock(circlePos)) {
+                            if (random.nextInt(16) == 0)
+                                world.setBlockType(circlePos, Blocks.MAGMA);
+                            else if (random.nextInt(4) == 0)
+                                world.setBlockType(circlePos, Blocks.COBBLE_BASALT);
+                        }
+                    }
+                }
+            }
+        }
+
+
+        return true;
+    }
+
+    private Block<?> getBlockAt(Vector2i center, int x, int z){
+        return Blocks.COBBLE_BASALT;
+    }
+
+    private void plotBlocks(World world, Vector2i center, TilePos queryPos, int x, int y, int z){
+
+        for(int xx = center.x - x; xx <= center.x + x; xx++) {
+            Block<?> block = getBlockAt(center, xx, center.y + z);
+            world.setBlockType(queryPos.set(xx, queryPos.y, center.y + z), block);
+            world.setBlockType(queryPos.set(xx, queryPos.y, center.y - z), block);
+        }
+
+        for(int xx = center.x - z; xx <= center.x + z; xx++) {
+            Block<?> block = getBlockAt(center, xx, center.y + x);
+            world.setBlockType(queryPos.set(xx, y, center.y + x), block);
+            world.setBlockType(queryPos.set(xx, y, center.y - x), block);
+        }
+    }
+
+    private void generateRadius(World world, Vector2i center, TilePos queryPos, double r, int y){
+        int x = 0;
+        int z = (int) r;
+        double d = 3 - 2 * r;
+        plotBlocks(world, center, queryPos, x, y, z);
+        while (z > x){
+            x++;
+            if (d > 0) {
+                z--;
+                d = d + 4 * (x - z) + 10;
+            }  else
+                d = d + 4 * x + 6;
+
+            plotBlocks(world, center, queryPos, x, y, z);
+        }
+    }
+
+    private boolean hasSpace(World world, int xc, int y, int zc){
+        TilePos queryPos =  new TilePos();
+        for (queryPos.y = y - 2; queryPos.y < y + 2; queryPos.y++) {
+            for (queryPos.x = xc - 2; queryPos.x < xc + 2; queryPos.x++) {
+                for (queryPos.z = zc - 2; queryPos.z < zc + 2; queryPos.z++) {
+                    if (!world.isAirBlock(queryPos) && !world.getBlockType(queryPos).hasTag(BlockTags.NETHER_SURFACE_BLOCK))
+                        return false;
+                }
+            }
+        }
+        return true;
+    }
+
+
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherPatch.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherPatch.java
new file mode 100644
index 000000000..77eee77a1
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherPatch.java
@@ -0,0 +1,34 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+
+import java.util.Random;
+
+public class WorldFeatureNetherPatch extends WorldFeature
+{
+    private final int blockId;
+    @MethodParametersAnnotation(names = {"blockId"})
+    public WorldFeatureNetherPatch(int blockId)
+    {
+        this.blockId = blockId;
+    }
+
+    @Override
+	public boolean place(World world, Random random, int x, int y, int z)
+    {
+        while(world.getBlockId(x, y, z) == 0 && y > 0) { y--; }
+        for(int i = 0; i < 8; i++)
+        {
+            int x1 = (x + random.nextInt(4)) - random.nextInt(4);
+            int y1 = (y + random.nextInt(4)) - random.nextInt(4);
+            int z1 = (z + random.nextInt(4)) - random.nextInt(4);
+            if(world.isAirBlock(x1, y1, z1) && Blocks.blocksList[blockId].canBlockStay(world, x1, y1, z1))
+            {
+                world.setBlock(x1, y1, z1, blockId);
+            }
+        }
+
+        return true;
+    }
+}
